/*
** Copyright (c) Massachusetts Institute of Technology 1994-1997.
**          All Rights Reserved.
**          Unpublished rights reserved under the copyright laws of
**          the United States.
**
** THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
** OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
**
** This code is distributed freely and may be used freely under the 
** following conditions:
**
**     1. This notice may not be removed or altered.
**
**     2. Works derived from this code are not distributed for
**        commercial gain without explicit permission from MIT 
**        (for permission contact lclint-request@larch.lcs.mit.edu).
*/
/*
** importNode.h
**
** needs "ltoken_type.h"
*/

typedef enum { IMPPLAIN, IMPBRACKET, IMPQUOTE } impkind ;

typedef struct _importNode
{
  impkind   kind;
  ltoken  val;
} *importNode ;

extern void importNode_free (/*@only@*/ /*@null@*/ importNode p_x);

extern /*@only@*/ importNode importNode_makePlain (/*@only@*/ ltoken p_t);
extern /*@only@*/ importNode importNode_makeBracketed (/*@only@*/ ltoken p_t);
extern /*@only@*/ importNode importNode_makeQuoted (/*@only@*/ ltoken p_t);
