/*
** Copyright (c) Massachusetts Institute of Technology 1994-1997.
**          All Rights Reserved.
**          Unpublished rights reserved under the copyright laws of
**          the United States.
**
** THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
** OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
**
** This code is distributed freely and may be used freely under the 
** following conditions:
**
**     1. This notice may not be removed or altered.
**
**     2. Works derived from this code are not distributed for
**        commercial gain without explicit permission from MIT 
**        (for permission contact lclint-request@larch.lcs.mit.edu).
*/

typedef enum {
  PRIV_CONST, PRIV_VAR, 
  PRIV_TYPE, PRIV_FUNCTION 
  } privateKind;

typedef struct _privateNode {
  privateKind kind;
  union {
    constDeclarationNode constdeclaration;
    varDeclarationNode vardeclaration;	
    typeNode type;
    fcnNode fcn;
  } content;
} *privateNode;

extern /*@unused@*/ /*@only@*/ cstring privateNode_unparse(privateNode p_n);
