/*
** Copyright (c) Massachusetts Institute of Technology 1994-1997.
**          All Rights Reserved.
**          Unpublished rights reserved under the copyright laws of
**          the United States.
**
** THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
** OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
**
** This code is distributed freely and may be used freely under the 
** following conditions:
**
**     1. This notice may not be removed or altered.
**
**     2. Works derived from this code are not distributed for
**        commercial gain without explicit permission from MIT 
**        (for permission contact lclint-request@larch.lcs.mit.edu).
*/
typedef enum 
{
  ACT_SELF, ACT_ITER, ACT_ALTERNATE, 
  ACT_SEQUENCE
  } actionKind;

typedef struct _programNode {
  int wrapped; /* number of balanced parentheses around this program node */
  actionKind kind;
  union {
    struct _stmtNode *self;
    struct _programNodeList *args;
  } content;
} *programNode;

extern void programNode_free (/*@only@*/ /*@null@*/ programNode p_x);
extern /*@only@*/ cstring programNode_unparse (programNode p_p);

